extends KinematicBody2D

const SPEED = 60
const GRAVITY = 10
const JUMP_POWER = -177
const FLOOR = Vector2(0, -1)

var velocity = Vector2()

var on_ground = false
var on_wait = true
var CollectedScrews

func die():
	get_tree().change_scene("res://GameOver.tscn")

func _process(delta):
	var ScrewCounter = get_node("Camera2D/UI/ScrewCounter")
	var Stage = get_parent().get_name()
	if Stage == "StageOne":
		CollectedScrews = 0
		if global.screw00: CollectedScrews += 1
		if global.screw01: CollectedScrews += 1
		if global.screw02: CollectedScrews += 1
		if global.screw03: CollectedScrews += 1
		if global.screw04: CollectedScrews += 1
		ScrewCounter.text = str(CollectedScrews) + "/5"

func _physics_process(delta):
	for i in get_slide_count():
		var collision = get_slide_collision(i)
		if collision.collider.name.find("Screw") == -1: die()
		
	if Input.is_action_pressed("ui_up"):
		velocity.y = JUMP_POWER
		on_wait = false
		
	elif Input.is_mouse_button_pressed(true):
		velocity.y = JUMP_POWER
		on_wait = false
		
		#if on_ground == true:
			#velocity.y = JUMP_POWER
			#on_ground = false
			
	if !on_wait:
		velocity.x = SPEED
		velocity.y += GRAVITY
	
	if is_on_floor():
		on_ground = true
	else:
		on_ground = false
	
	velocity = move_and_slide(velocity, FLOOR)

func _on_FinishLine_body_entered(body):
	get_tree().change_scene("res://StageSelect.tscn")